#!/bin/bash

_HOSTNAME=$(hostname -A | head -1)

# Bin paths
DF=/bin/df
GREP=/bin/grep
AWK=/usr/bin/awk
LOGGER=/usr/bin/logger
ECHO=/bin/echo
FIND=/usr/bin/find
BASENAME=/usr/bin/basename
MAIL=/usr/bin/mail
PUSHOVER=/usr/local/bin/pushover.sh

# Output variables
EMAIL_ADDRESS={{ notification.gmail.email }}
PUSHOVER_USER_KEY={{ notification.pushover.user_key }}
PUSHOVER_APP_TOKEN={{ notification.pushover.roles[current_group_role].disk_space_watchdog_token }}

# Possible values
#   * log
#   * pushover
#   * gmail
OUTPUT_METHOD="gmail"

# Misc variables
ALERT_LEVEL=90


# $1: Subject
# $2: Content
_output() {
    case $OUTPUT_METHOD in
        gmail)
            $ECHO "$1" |
            $MAIL -s "$2" "$EMAIL_ADDRESS"
            ;;
    
        pushover)
            $PUSHOVER -U $PUSHOVER_USER_KEY -T $PUSHOVER_APP_TOKEN -t "$1" "$2"
            ;;

        log)
            $LOGGER -t "$0" "$1: $2"
            ;;
    esac
}


# The following command displays fields 5 and 1 of the `df` command, then loop on the results.
$DF -H | $GREP -vE '^Filesystem|none|cdrom' | $AWK '{ print $5 " " $1 }' | while read output;
do
    $ECHO $output

    USE_PERCENTAGE=$($ECHO $output | $AWK '{ print $1}' | cut -d'%' -f1  )
    PARTITION=$($ECHO $output | $AWK '{ print $2 }' )

    # If hard drive space taken is >= $ALERT_LEVEL%
    if [ $USE_PERCENTAGE -ge $ALERT_LEVEL ]; then
        DRIVE_FULL_PATH=`$FIND -L /dev/disk/by-label -inum $(stat -c %i $PARTITION) -print`
        DRIVE_NAME=`$BASENAME $DRIVE_FULL_PATH`

        if [[ $DRIVE_NAME != PARITY_* ]]; then
            _output "[$_HOSTNAME] Alert: Almost out of disk space $USE_PERCENTAGE%" \
                    "Running out of space on $_HOSTNAME as on $(date)
Drive: \\\"(${USE_PERCENTAGE}%) $DRIVE_NAME ($PARTITION)\\\""
        fi
    fi
done
